#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "NQDSSrv.h"
#include "NQDSThread.h"

static BOOL InitWinsocket()
{
	WORD wVersionRequested;WSADATA wsaData;int err; 
	wVersionRequested = MAKEWORD( 2, 2 ); 
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) 
	{
		/* Tell the user that we could not find a usable */
		/* WinSock DLL.                                  */    
		return FALSE;
	} 
	/* Confirm that the WinSock DLL supports 2.2.		 */
	/* Note that if the DLL supports versions greater    */
	/* than 2.2 in addition to 2.2, it will still return */
	/* 2.2 in wVersion since that is the version we      */
	/* requested.                                        */ 
	if ( LOBYTE( wsaData.wVersion ) != 2 || HIBYTE( wsaData.wVersion ) != 2 ) 
	{
		/* Tell the user that we could not find a usable */
		/* WinSock DLL.                                  */    
		WSACleanup();
		return FALSE; 
	}
	return TRUE;
}

void main()
{
	InitTrace();
	FILE *fTraceOut = fopen( "TraceOut", "w+t" );
	if ( !fTraceOut )
	{
		TRACE( "Error creating trace output file!\n" );
		return;
	}
	g_fDebugOut = fTraceOut;
	if ( !InitWinsocket() )
	{
		TRACE( "Error executing WSAStartup\n" );
		return;
	}
	// TODO: Your own implementation here!
	CNQDSThread nqdsThread1;
	CNQDSThread nqdsThread2;
	CNQDSThread nqdsThread3;
	in_addr addrSelf, addrPeer;
	addrSelf.S_un.S_un_b.s_b1 = 204;
	addrSelf.S_un.S_un_b.s_b2 = 175;
	addrSelf.S_un.S_un_b.s_b3 = 197;
	addrSelf.S_un.S_un_b.s_b4 = 100;

	in_addr addrSelfInt;
	addrSelfInt.S_un.S_un_b.s_b1 = 200;
	addrSelfInt.S_un.S_un_b.s_b2 = 0;
	addrSelfInt.S_un.S_un_b.s_b3 = 0;
	addrSelfInt.S_un.S_un_b.s_b4 = 23;

	if ( CNQDSThread::m_BroadcastThread.CreateThread( addrSelfInt, 5001 ) )
	{
		addrPeer.S_un.S_un_b.s_b1 = 224;
		addrPeer.S_un.S_un_b.s_b2 = 0;
		addrPeer.S_un.S_un_b.s_b3 = 1;
		addrPeer.S_un.S_un_b.s_b4 = 91;
		if ( nqdsThread1.CreateThread( addrSelf, addrPeer, 55252 ) )
			TRACE( "Thread1 created successfully!\n" );

		addrPeer.S_un.S_un_b.s_b1 = 224;
		addrPeer.S_un.S_un_b.s_b2 = 0;
		addrPeer.S_un.S_un_b.s_b3 = 1;
		addrPeer.S_un.S_un_b.s_b4 = 92;
		if ( nqdsThread2.CreateThread( addrSelf, addrPeer, 55254 ) )
			TRACE( "Thread2 created successfully!\n" );

		addrPeer.S_un.S_un_b.s_b1 = 224;
		addrPeer.S_un.S_un_b.s_b2 = 0;
		addrPeer.S_un.S_un_b.s_b3 = 1;
		addrPeer.S_un.S_un_b.s_b4 = 93;
		if ( nqdsThread3.CreateThread( addrSelf, addrPeer, 55256 ) )
			TRACE( "Thread3 created successfully!\n" );
	}
	else
		TRACE( "Broadcast thread failed to create!\n" );

	getchar();

	nqdsThread1.SafeTerminateAndCleanUp();
	nqdsThread2.SafeTerminateAndCleanUp();
	nqdsThread3.SafeTerminateAndCleanUp();
	CNQDSThread::m_BroadcastThread.SafeTerminateAndCleanUp();

	TRACE( "Thread 1 lost %d packets!\n", nqdsThread1.GetLostCount() );
	TRACE( "Thread 2 lost %d packets!\n", nqdsThread2.GetLostCount() );
	TRACE( "Thread 3 lost %d packets!\n", nqdsThread3.GetLostCount() );
	WSACleanup();
	fclose(fTraceOut);
	TraceCleanUp();
}

